package com.xunlei.aplyer.aplayerdemo;

import android.annotation.SuppressLint;
import android.content.Context;
import android.content.Intent;
import android.content.pm.ActivityInfo;
import android.content.res.Configuration;
import android.graphics.Bitmap;
import android.media.MediaFormat;
import android.media.MediaScannerConnection;
import android.net.Uri;
import android.os.Bundle;
import android.os.Environment;
import android.os.Handler;
import android.os.Message;
import android.os.ParcelFileDescriptor;
import android.os.SystemClock;
import android.support.v7.app.ActionBar;
import android.support.v7.app.AppCompatActivity;
import android.util.Log;
import android.view.Gravity;
import android.view.Menu;
import android.view.MotionEvent;
import android.view.SurfaceView;
import android.view.TextureView;
import android.view.View;
import android.view.Window;
import android.view.WindowManager;
import android.widget.Button;
import android.widget.FrameLayout;
import android.widget.ImageView;
import android.widget.PopupWindow;
import android.widget.SeekBar;
import android.widget.TextView;
import android.widget.Toast;

import com.aplayer.APlayerAndroid;
import com.xunlei.aplyer.aplayerdemo.model.APlayerParam;
import com.xunlei.aplyer.aplayerdemo.model.PlayConfig;
import com.xunlei.aplyer.aplayerdemo.play_implement.ConfigAudio;
import com.xunlei.aplyer.aplayerdemo.play_implement.ConfigSubtitle;
import com.xunlei.aplyer.aplayerdemo.play_implement.ConfigVideo;
import com.xunlei.aplyer.aplayerdemo.play_implement.Record;
import com.xunlei.aplyer.aplayerdemo.play_interface.IConfigVideo;
import com.xunlei.aplyer.aplayerdemo.ui.PlayerPopupWindow;
import com.xunlei.aplyer.aplayerdemo.util.APlayerSationUtil;
import com.xunlei.aplyer.aplayerdemo.util.BoolUtil;
import com.xunlei.aplyer.aplayerdemo.util.CommonConst;
import com.xunlei.aplyer.aplayerdemo.util.PropertyNameToConfigID;
import com.xunlei.aplyer.aplayerdemo.util.TimeUtil;

import java.io.File;
import java.io.FileDescriptor;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Map;
import java.util.concurrent.locks.ReentrantLock;

import static com.xunlei.aplyer.aplayerdemo.util.PreferencesAttribute.getPreferencesAll;

/**
 * An example full-screen activity that shows and hides the system UI (i.e.
 * status bar and navigation/system bar) with user interaction.
 */
public class PlayerActivity extends AppCompatActivity {

    private static final String TAG = "APlayerActivity";
    /**
     * Whether or not the system UI should be auto-hidden after
     * {@link #AUTO_HIDE_DELAY_MILLIS} milliseconds.
     */
    private static final boolean AUTO_HIDE = true;

    /**
     * If {@link #AUTO_HIDE} is set, the number of milliseconds to wait after
     * user interaction before hiding the system UI.
     */
    private static final int AUTO_HIDE_DELAY_MILLIS = 3000;

    /**
     * Some older devices needs a small delay between UI widget updates
     * and a change of the status and navigation bar.
     */
    private static final int UI_ANIMATION_DELAY = 300;



    private final Runnable mHidePart2Runnable = new Runnable() {
        @SuppressLint("InlinedApi")
        @Override
        public void run() {
            // Delayed removal of status and navigation bar

            // Note that some of these constants are new as of API 16 (Jelly Bean)
            // and API 19 (KitKat). It is safe to use them, as they are inlined
            // at compile-time and do nothing on earlier devices.
            mContentView.setSystemUiVisibility(View.SYSTEM_UI_FLAG_LOW_PROFILE
                    | View.SYSTEM_UI_FLAG_FULLSCREEN
                    | View.SYSTEM_UI_FLAG_LAYOUT_STABLE
                    | View.SYSTEM_UI_FLAG_IMMERSIVE_STICKY
                    | View.SYSTEM_UI_FLAG_LAYOUT_HIDE_NAVIGATION
                    | View.SYSTEM_UI_FLAG_HIDE_NAVIGATION);
        }
    };

    private final Runnable mShowPart2Runnable = new Runnable() {
        @Override
        public void run() {
            // Delayed display of UI elements
            mControlsView.setVisibility(View.VISIBLE);
        }
    };

    private final Runnable mHideRunnable = new Runnable() {
        @Override
        public void run() {
            hide();
        }
    };
    /**
     * Touch listener to use for in-spacer_medium UI controls to delay hiding the
     * system UI. This is to prevent the jarring behavior of controls going away
     * while interacting with activity UI.
     */
    private final View.OnTouchListener mDelayHideTouchListener = new View.OnTouchListener() {
        @Override
        public boolean onTouch(View view, MotionEvent motionEvent) {
            if (AUTO_HIDE) {
                delayedHide(AUTO_HIDE_DELAY_MILLIS);
            }
            return false;
        }
    };

    private Context mContext;
    private View mContentView;
    private View mControlsView;
    private FrameLayout mRootView;
    private SurfaceView mSurView;
    private TextView mTextViewCurrentTime;
    private TextView mTextViewDurationTime;
    private TextView mTextViewSubtitle;
    private SeekBar mSeekBarPlayProgress;
    private ImageView mBtnPlaySeting;
    private PopupWindow mPopupWindow = null;
    private TextView mTextViewSeekTime = null;         //拖动进度条时，在屏幕中央以大字体显示当前的进度
    private TextView mTextViewBufferProgress = null;         //拖动进度条时，在屏幕中央以大字体显示当前的进度
    private ImageView mPlayPauseSwitchButton;
    private ImageView mPlayPreButton;
    private ImageView mPlayNextButton;
    private ImageView mPlayModeButton;
    private ImageView mReplayModeButton;
    private ImageView mThumbnail;
    private TextView mPathTextView;
    private TextView mCurrentFramerateTextView;

    private volatile boolean mIsTouchingSeekbar = false;
    private boolean mVisible;
    private boolean mOnCreateFlag = true;

    private static final int UI_UPDATE_PLAY_STATION = 0X1000;//更新视频持续时间
    private static final int UI_UPDATE_FRAMERATE_STATION = 0X1001;//更新视频帧率时间
    private static final int TIMER_UPDATE_INTERVAL_TIME = 100;   //定时器时间间隔，更新播放进度
    private APlayerAndroid aPlayer = null;
    private APlayerAndroid.OnPlayCompleteListener mPlayCompleteListener = null;
    private APlayerParam mAPlayerParam;
    private ParcelFileDescriptor mpDescriptor = null;
    private PlayConfig mPlayConfig = null;            //播放配置接口,部分和具体媒体文件强相关的参数，必须打开文件成功后设置
    private boolean mIsNeedUpdateUIProgress = false;   //标志位，是否需要更新播放进度
    private Thread mUpdateThread = null;
    private final EventHandler mHandler = new EventHandler();
    private String mUri;
    private ArrayList<String> mPlayList;
    private ThumbnailThread mThumbnailThread = new ThumbnailThread();
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        this.requestWindowFeature(Window.FEATURE_NO_TITLE);
        this.getWindow().setFlags(WindowManager.LayoutParams.FLAG_FULLSCREEN,
                WindowManager.LayoutParams.FLAG_FULLSCREEN);
        setContentView(R.layout.activity_player);
        mVisible = true;
        mContext = getApplicationContext();
        Intent intent = getIntent();
        mUri = parseMediaPath(intent.getData());
        mPlayList = intent.getStringArrayListExtra(CommonConst.PLAY_LIST_INTENT_KEY);//获取当前目录的播放列表，可能不完整
        Map<String, String> pramMap  = getPreferencesAll(mContext);
        mAPlayerParam = new APlayerParam(pramMap);
        if (null == mUri || null == pramMap) {
            Log.e(TAG, "APlayerParam is't effective");
        }

        getComponent();
        initPlayer();
        setPlayerParameter();
        boolean isUseVR = isUseVR(aPlayer);
        if(isUseVR) hide();
        mContentView = getDisplayView(isUseVR);
        if(isUseVR) setVRMode();
        
        setScreenOrientation(false);
        initPlayConfig(mContentView);
        setPlayerView(isUseVR);

        hideActionBar();
        registerListener();

        mHandler.postAtTime(new Runnable() {
            @Override
            public void run() {
                play();
            }
        },500);

        new Thread(new UpdateFramerateUIProcess()).start();
    }

    private Map<String, String> getDeafultConfigParam()
    {
        Map<String, String> configParam = new HashMap<String, String>();
        return null;
    }
    private APlayerParam getDefaultPlayerParam(String mediaFilePath)
    {
        Map<String, String> configParam = getDeafultConfigParam();
        APlayerParam aPlayerParam = new APlayerParam(configParam);
        return aPlayerParam;
    }
    private void setVRMode()
    {
        Map<String, String> configParam = mAPlayerParam.getConfigParam();
        if(null == configParam){
            return;
        }

        PropertyNameToConfigID propertyNameToConfigID = PropertyNameToConfigID.getInstance(this);
        String vrModeKey = getString(R.string.PREF_VR_MODE);
        String vrModeVal = configParam.get(vrModeKey);
        if(null == vrModeKey || null == vrModeVal){
            Log.e(TAG, "SetConfig() faile " + "vrModeKey = " + vrModeKey + " vrModeVal = " + vrModeVal);
        }

        int configID = propertyNameToConfigID.getIDByName(vrModeKey);
        if (0 != aPlayer.setConfig(configID, vrModeVal)) {
             Log.e(TAG, "SetConfig() faile " + "configID = " + configID + " val = " + vrModeVal);
        }
    }

    private void setScreenOrientation(boolean isUseVR)
    {
        int orientation = isUseVR ? ActivityInfo.SCREEN_ORIENTATION_LANDSCAPE : ActivityInfo.SCREEN_ORIENTATION_UNSPECIFIED;
        setRequestedOrientation(orientation);
    }

    private void initPlayConfig(View displayView)
    {
        final String filePath = mUri;
        PlayConfig.PlayerListener playerListener = new PlayConfig.PlayerListener();
        playerListener.playCompleteListener = mPlayCompleteListener;
        mPlayConfig = new PlayConfig(new ConfigVideo(aPlayer, filePath, playerListener, displayView),
                new ConfigAudio(aPlayer), new ConfigSubtitle(aPlayer), new Record(aPlayer));
    }

    private static boolean isUseVR(APlayerAndroid aPlayerAndroid) {
        boolean IsUseVR = false;
        if(null != aPlayerAndroid){
            IsUseVR = BoolUtil.APlayerConfigValToBool(aPlayerAndroid.getConfig(APlayerAndroid.CONFIGID.VR_ENABLE));
        }

        return IsUseVR;
    }

    private View getDisplayView(boolean isVRView) {
        View displayView = null;
        if(isVRView) {
//            displayView = aPlayer.createVRView(this);
//            mRootView.addView(displayView);
//            DisplayAreaSetUtil.adjustMatchParentDisplaySize(displayView);
//            //DisplayAreaSetUtil.adjustCustomRatioDisplaySize(displayView,1);
//            mRootView.bringChildToFront(findViewById(R.id.player_set_root));
//            mRootView.bringChildToFront(findViewById(R.id.play_setting));
        }
        else
        {
            displayView = mSurView;
        }

        return displayView;
    }

    private void getComponent() {
        mRootView = (FrameLayout)findViewById(R.id.play_view_root);
        mControlsView = findViewById(R.id.player_control);

        mSurView = (SurfaceView) findViewById(R.id.fullscreen_content);
        mTextViewCurrentTime = (TextView) findViewById(R.id.play_time);
        mTextViewDurationTime = (TextView) findViewById(R.id.duration_time);
        mTextViewSubtitle = (TextView) findViewById(R.id.textView_Subtitle);
        mSeekBarPlayProgress = (SeekBar) findViewById(R.id.play_seek_bar);
        mBtnPlaySeting = (ImageView) findViewById(R.id.play_setting);
        mTextViewSeekTime = (TextView) findViewById(R.id.play_seek_time_text_view);
        mTextViewBufferProgress = (TextView) findViewById(R.id.play_buffering_text_view);

        mTextViewCurrentTime.setText(TimeUtil.formatFromSecond(0));
        mTextViewDurationTime.setText(TimeUtil.formatFromSecond(0));
        mTextViewSeekTime.setVisibility(View.INVISIBLE);
        mTextViewBufferProgress.setVisibility(View.INVISIBLE);

        mPlayPauseSwitchButton = (ImageView) findViewById(R.id.button_play_pause);
        mPlayNextButton = (ImageView) findViewById(R.id.button_play_next);
        mPlayPreButton = (ImageView) findViewById(R.id.button_play_pre);
        mPlayModeButton = (ImageView) findViewById(R.id.button_play_mode);
        mReplayModeButton = (ImageView) findViewById(R.id.button_replay_mode);
        mThumbnail = (ImageView) findViewById(R.id.imageView_thumbnail);
        mThumbnail.setVisibility(View.INVISIBLE);
        mPathTextView = (TextView)findViewById(R.id.current_path);
        mCurrentFramerateTextView = (TextView)findViewById(R.id.current_framerate);
    }

    @Override
    protected void onPostCreate(Bundle savedInstanceState) {
        super.onPostCreate(savedInstanceState);

        // Trigger the initial hide() shortly after the activity has been
        // created, to briefly hint to the user that UI controls
        // are available.

        //delayedHide(100);
    }

    private void toggle() {
        if (mVisible) {
            hide();
        } else {
            show();
        }
    }

    private void hide() {
        // Hide UI first
        ActionBar actionBar = getSupportActionBar();
        if (actionBar != null) {
            actionBar.hide();
        }
        mBtnPlaySeting.setVisibility(View.INVISIBLE);
        mControlsView.setVisibility(View.GONE);
        mVisible = false;

        // Schedule a runnable to remove the status and navigation bar after a delay
        mHandler.removeCallbacks(mShowPart2Runnable);
        mHandler.postDelayed(mHidePart2Runnable, UI_ANIMATION_DELAY);
    }

    @SuppressLint("InlinedApi")
    private void show() {
        mBtnPlaySeting.setVisibility(View.VISIBLE);
        // show the system bar
        mContentView.setSystemUiVisibility(View.SYSTEM_UI_FLAG_LAYOUT_FULLSCREEN
                | View.SYSTEM_UI_FLAG_LAYOUT_HIDE_NAVIGATION);
        mVisible = true;

        // Schedule a runnable to display UI elements after a delay
        mHandler.removeCallbacks(mHidePart2Runnable);
        mHandler.postDelayed(mShowPart2Runnable, UI_ANIMATION_DELAY);
    }

    /**
     * Schedules a call to hide() in [delay] milliseconds, canceling any
     * previously scheduled calls.
     */
    private void delayedHide(int delayMillis) {
        mHandler.removeCallbacks(mHideRunnable);
        mHandler.postDelayed(mHideRunnable, delayMillis);
    }

    @Override
    protected void onPause() {

        int statue = aPlayer.getState();
        /*if (isPlay(statue)) {
            aPlayer.pause();
            mIsSystemCallPause = true;
        }else{
            mIsSystemCallPause = false;
        }*/
        aPlayer.activityPause();

        //让播放进度UI更新线程退出
        stopUIUpdateThread();
        Toast.makeText(getApplicationContext(), "statue = " + statue, Toast.LENGTH_SHORT).show();
        Log.e(TAG, "onPause zxcvbnm,.");
        super.onPause();
    }

    @Override
    protected void onResume() {
        //普通播放，后台切换回来，恢复之前的播放状态
       /* boolean isUseVR = isUseVR(aPlayer);
        //setPlayerView(isUseVR);
        if (mIsSystemCallPause) {
            aPlayer.play();aPlayer.play();
            //mIsSystemCallPause = false;
        }*/

        aPlayer.activityResume();
        startUIUpdateThread();
        Log.e(TAG, "onResume 123456789");
        super.onResume();
    }

    @Override
    protected void onStop() {
        Log.e(TAG, "OnStop...");
        super.onStop();
    }

    @Override
    protected void onDestroy() {
        aPlayer.close();
        mOnCreateFlag = false;
        aPlayer.destroy();
        destroyPopWind();
        super.onDestroy();

        Log.e(TAG, "onDestroy()");
    }

    @Override
    public void onConfigurationChanged(Configuration newConfig) {
        super.onConfigurationChanged(newConfig);
        resetDisplayAreaSize();
    }

    //Screen orientation change, or file open success adjust diaplay area size(aftern open file, can get the native ration)
    void resetDisplayAreaSize()
    {
        if(null == mPlayConfig)
        {
            return;
        }
        IConfigVideo configVideo = mPlayConfig.getConfigVideo();
        if(null == configVideo)
        {
            return;
        }

        IConfigVideo.AspectRatioType aspectRatioType = configVideo.getAspectRatioType();
        String aspectCustomParam = null;
        if(IConfigVideo.AspectRatioType.RatioCustom == aspectRatioType)
        {
            aspectCustomParam = configVideo.getAspectRatioCustom();
        }
        configVideo.setAspectRatioType(aspectRatioType, aspectCustomParam);
    }

    private void hideActionBar() {
        ActionBar actionBar = getSupportActionBar();
        if (actionBar != null) {
            actionBar.hide();
        }
    }

    private void destroyPopWind() {
        if (null != mPopupWindow) {
            mPopupWindow.dismiss();
            mPopupWindow = null;
        }
    }
    private class EventHandler extends Handler
    {
        @Override
        public void handleMessage(Message msg) {
            switch (msg.what) {
                case UI_UPDATE_PLAY_STATION:
                    updateUIPlayStation(msg.arg1, msg.arg2);
                    break;
                case UI_UPDATE_FRAMERATE_STATION:
                    if ( msg.obj instanceof String ) {
                        mCurrentFramerateTextView.setText((String) msg.obj);
                    }
                    break;
                default:
                    break;
            }
        }
    }

    private class UpdatePlayUIProcess implements Runnable {
        @Override
        public void run() {
            //while(!Thread.currentThread().isInterrupted())
            while (mIsNeedUpdateUIProgress) {
                if (!mIsTouchingSeekbar) {
                    int currentPlayTime = 0;
                    int durationTime = 0;
                    if (null != aPlayer) {
                        currentPlayTime = aPlayer.getPosition();
                        durationTime = aPlayer.getDuration();
                    }

                    Message msg = mHandler.obtainMessage(UI_UPDATE_PLAY_STATION, currentPlayTime, durationTime);
                    mHandler.sendMessage(msg);
                }

                try {
                    Thread.sleep(TIMER_UPDATE_INTERVAL_TIME);
                } catch (InterruptedException e) {
                    Log.e(TAG, e.toString());
                }
            }

        }
    }

    private class UpdateFramerateUIProcess implements Runnable {
        @Override
        public void run() {
            Log.e(TAG, "UpdateFramerateUIProcess,enter");
            while ( mOnCreateFlag ) {
                if ( null != aPlayer ) {
                    String text = aPlayer.getConfig(APlayerAndroid.CONFIGID.FRAMERATE_CURRENT);
                    if ( !text.isEmpty() ) {
                        Message msg = mHandler.obtainMessage(UI_UPDATE_FRAMERATE_STATION, text + "fps");
                        mHandler.sendMessage(msg);
                    }
                }
                try {
                    Thread.sleep(500);
                } catch ( InterruptedException e ) {
                    Log.e(TAG, e.toString());
                }
            }
            Log.e(TAG, "UpdateFramerateUIProcess,exit");
        }
    }


    private void updateUIPlayStation(int currentPlayTimeMs, int durationTimeMs) {
        setTimeTextView(mTextViewCurrentTime, currentPlayTimeMs);
        setTimeTextView(mTextViewDurationTime, durationTimeMs);

        if (durationTimeMs > 0 && currentPlayTimeMs >= 0) {
            mSeekBarPlayProgress.setMax(durationTimeMs);
            mSeekBarPlayProgress.setProgress(currentPlayTimeMs);
        } else {
            mSeekBarPlayProgress.setProgress(0);
        }

    }

    private void setTimeTextView(TextView timeView, int millisecond) {
        int second = millisecond / 1000;
        second = second > 0 ? second : 0;  //媒体文件未打开时，播放位置字段无效
        timeView.setText(TimeUtil.formatFromSecond(second));
    }

    private void setBufferProgress(int progress) {
        int visibility = (progress == 100) ? View.INVISIBLE : View.VISIBLE;
        mTextViewBufferProgress.setVisibility(visibility);
        String strProgress = progress + "%";
        mTextViewBufferProgress.setText(strProgress);
    }

    private void initPlayer() {
        if (null != aPlayer) {
            return;
        }

        aPlayer = new APlayerAndroid();
//        String data = aPlayer.getConfig(APlayerAndroid.CONFIGID.FIND_STREAM_INFO);
//        Log.e(TAG, "try_find_stream_info,data="+data);
//        aPlayer.setConfig(APlayerAndroid.CONFIGID.FIND_STREAM_INFO, "1");
//        data = aPlayer.getConfig(APlayerAndroid.CONFIGID.FIND_STREAM_INFO);
//        Log.e(TAG, "try_find_stream_info,data="+data);

//        aPlayer.setConfig(APlayerAndroid.CONFIGID.CLEAR_CONFIG, "0");
//        aPlayer.setConfig(APlayerAndroid.CONFIGID.HTTP_AHTTP2_USE_CACHE, "1");
//        String HTTP_AHTTP2_CACHE_DIR = aPlayer.getConfig(APlayerAndroid.CONFIGID.HTTP_AHTTP2_CACHE_DIR);
//        Log.e(TAG, "HTTP_AHTTP2_CACHE_DIR="+HTTP_AHTTP2_CACHE_DIR);
//        aPlayer.setConfig(APlayerAndroid.CONFIGID.HTTP_AHTTP2_CACHE_DIR, HTTP_AHTTP2_CACHE_DIR+"aaaaaa/");
        printfGetConfig(aPlayer);
        //aPlayer.setConfig(APlayerAndroid.CONFIGID.ONLY_AUDIO,"1");
        //aPlayer.useSystemPlayer(true);
        aPlayer.setOnOpenSuccessListener(new APlayerAndroid.OnOpenSuccessListener() {
            @Override
            public void onOpenSuccess() {
                aPlayer.play();

                Log.w(TAG, "mAVIndexEntry");
                //APlayerAndroid.AVIndexEntry[] mAVIndexEntry = aPlayer.getAVIndexEntry(APlayerAndroid.AVINDEX_UNKEYFRAME);
                //APlayerAndroid.AVIndexEntry[] mAVIndexEntry = aPlayer.getAVIndexEntry(APlayerAndroid.AVINDEX_KEYFRAME|APlayerAndroid.AVINDEX_UNKEYFRAME);
                //APlayerAndroid.AVIndexEntry[] mAVIndexEntry = aPlayer.getAVIndexEntry(APlayerAndroid.AVINDEX_KEYFRAME|APlayerAndroid.AVINDEX_UNKEYFRAME|APlayerAndroid.AVINDEX_DISCARD_FRAME);
                APlayerAndroid.AVIndexEntry[] mAVIndexEntry = aPlayer.getAVIndexEntry();
                if ( mAVIndexEntry==null ) {
                    Log.w(TAG, "mAVIndexEntry==null");
                } else {
                    for ( int i=0; i<mAVIndexEntry.length; i++ ) {
                        Log.w(TAG, "mAVIndexEntry:"
                                +",flags="+mAVIndexEntry[i].flags
                                +",pos="+mAVIndexEntry[i].pos
                                +",size="+mAVIndexEntry[i].size
                                +",timestamp="+mAVIndexEntry[i].timestamp
                                +",millisecond="+mAVIndexEntry[i].millisecond
                        );
                    }
                }
                startUIUpdateThread();
                mPlayPauseSwitchButton.setImageResource(R.drawable.btn_stop);

                //test code,avoid listener covered
                aPlayer.setOnPlayCompleteListener(mPlayCompleteListener);
                resetDisplayAreaSize();
                //switch vr mode,need reset orientation
                //setScreenOrientation(isUseVR(aPlayer));



//                {
//                    //test
//                    long[] offset = {1000000,10000000,30000000};
//                    long [] a = aPlayer.getTimeFromFileOffset(offset);
//                    for (int i = 0;i < a.length;i++){
//                        Log.e(TAG,"lzmlsfe her i = " + i + " value = " + a[i]);
//                    }
//                }
            }
        });

        aPlayer.setOnPreciseSeekCompleteListener(new APlayerAndroid.OnPreciseSeekCompleteListener() {
            @Override
            public void onPreciseSeekComplete() {
                /*Thread thread = new Thread() {
                    public void run() {
                        Log.e("meee", "start getCurrentScreenshot");
                        Bitmap bitmap = aPlayer.getCurrentScreenshot();
                        Log.e("meee", "end getCurrentScreenshot ");
                        String filePath = Environment.getExternalStorageDirectory() + "/a.jpeg";
                        if (filePath == null) {
                            //return null;
                        }

                        FileOutputStream fos;
                        try {
                            fos = new FileOutputStream(filePath);
                            bitmap.compress(Bitmap.CompressFormat.JPEG, 100, fos);
                            fos.close();
                        } catch (Exception e) {
                            Log.e("meee", "FileNotFoundException", e);
                        }

                    }
                };
                thread.start();*/
            }
        });

        aPlayer.setOnOpenCompleteListener(new APlayerAndroid.OnOpenCompleteListener() {
            public void onOpenComplete(boolean isOpenSuccess) {
                Log.e(TAG, "event setOnOpenCompleteListener " + (isOpenSuccess ? "success" : "fail"));
                //aPlayer.play();
                mHandler.post(new Runnable() {
                    @Override
                    public void run() {
                        boolean isHWMode = false;
                        String enableStr = aPlayer.getConfig(APlayerAndroid.CONFIGID.HW_DECODER_ENABLE);
                        String useStr = aPlayer.getConfig(APlayerAndroid.CONFIGID.HW_DECODER_USE);
                        if(enableStr != null && useStr != null){
                            isHWMode = enableStr.equals("1") && useStr.equals("1");
                        }
                        String str = isHWMode?"硬解模式\n":"软解模式\n";
                        mPathTextView.setText(str+mUri.substring(mUri.lastIndexOf("/")+1));
                    }
                });
            }
        });


        aPlayer.setOnPlayStateChangeListener(new APlayerAndroid.OnPlayStateChangeListener() {

            @Override
            public void onPlayStateChange(int nCurrentState, int nPreState) {
                Log.e(TAG, "event onPlayStateChange nCurrentState = " + nCurrentState + " nPreState = " + nPreState);
                if (APlayerAndroid.PlayerState.APLAYER_PLAYING == nCurrentState) {
                    startUIUpdateThread();
                    Log.e(TAG, "Start UpdateUIThread()");
                } else {
                    stopUIUpdateThread();
                    Log.e(TAG, "Stop UpdateUIThread()");
                }
            }
        });

        mPlayCompleteListener = new APlayerAndroid.OnPlayCompleteListener() {
            @Override
            public void onPlayComplete(String playRet) {
                Log.e(TAG, "event onPlayComplete  playRet = " + playRet);
                if(playRet.equals(APlayerAndroid.PlayCompleteRet.PLAYRE_RESULT_COMPLETE_KEEP_STREAM)){
                    return;
                }
                if ( playRet.equals(APlayerAndroid.PlayCompleteRet.PLAYRE_RESULT_COMPLETE)
                        ||playRet.equals(APlayerAndroid.PlayCompleteRet.PLAYRE_RESULT_CLOSE) ) {
                    printfGetConfig(aPlayer);
                }
                boolean isUseCallStop = APlayerSationUtil.isStopByUserCall(playRet);
                if (!isUseCallStop) {
                    finish();           //只在自然播放结束后退出
                    //play();
                }

                APlayerAndroid.StatisticsInfo statisticsInfo = aPlayer.getStatisticsInfo();
                com.aplayer.Log.i(TAG,"statisticsInfo playTime = " + statisticsInfo.playTime);
                com.aplayer.Log.i(TAG,"statisticsInfo seekCount = " + statisticsInfo.seekCount);
                com.aplayer.Log.i(TAG,"statisticsInfo seekBufferCount = " + statisticsInfo.seekBufferCount);
                com.aplayer.Log.i(TAG,"statisticsInfo seekBufferTime = " + statisticsInfo.seekBufferTime);
                com.aplayer.Log.i(TAG,"statisticsInfo normalBufferCount = " + statisticsInfo.normalBufferCount);
                com.aplayer.Log.i(TAG,"statisticsInfo normalBufferTime = " + statisticsInfo.normalBufferTime);
                com.aplayer.Log.i(TAG,"statisticsInfo firstRenderTime = " + statisticsInfo.firstRenderTime);
                com.aplayer.Log.i(TAG,"statisticsInfo openSuccessTime = " + statisticsInfo.openSuccessTime);
                com.aplayer.Log.i(TAG,"statisticsInfo fileSize = " + statisticsInfo.fileSize);
                com.aplayer.Log.i(TAG,"statisticsInfo duration = " + statisticsInfo.duration);
                com.aplayer.Log.i(TAG,"statisticsInfo audioCodecName = " + statisticsInfo.audioCodecName);
                com.aplayer.Log.i(TAG,"statisticsInfo videoCodecName = " + statisticsInfo.videoCodecName);
                com.aplayer.Log.i(TAG,"statisticsInfo subtitleCodecName = " + statisticsInfo.subtitleCodecName);
                com.aplayer.Log.i(TAG,"statisticsInfo containerName = " + statisticsInfo.containerName);
                com.aplayer.Log.i(TAG,"statisticsInfo error = " + statisticsInfo.error);
                com.aplayer.Log.i(TAG,"statisticsInfo streamType = " + statisticsInfo.streamType);
                com.aplayer.Log.i(TAG,"statisticsInfo videoFrameRate = " + statisticsInfo.videoFrameRate);
                com.aplayer.Log.i(TAG,"statisticsInfo errorId = " + statisticsInfo.errorId);
                com.aplayer.Log.i(TAG,"statisticsInfo isHwdecoder = " + statisticsInfo.isHwdecoder);
                com.aplayer.Log.i(TAG,"statisticsInfo isFindStreamInfo = " + statisticsInfo.isFindStreamInfo);

                for ( String key : statisticsInfo.map.keySet() ) {
                    Log.i(TAG,"zhipeng.li " + key + " ：" + statisticsInfo.map.get(key));
                }
            }
        };
        aPlayer.setOnPlayCompleteListener(mPlayCompleteListener);

        aPlayer.setOnSeekCompleteListener(new APlayerAndroid.OnSeekCompleteListener() {
            @Override
            public void onSeekComplete() {
                // TODO Auto-generated method stub
                Log.e(TAG, "event onSeekComplete = ");

            }
        });

        aPlayer.setOnBufferListener(new APlayerAndroid.OnBufferListener() {

            @Override
            public void onBuffer(int progress) {
                Log.e(TAG, "event onBuffer progress = " + progress);
                //((TextView) findViewById(R.id.textView1)).setText(progress+ " ");
                setBufferProgress(progress);
            }
        });

        aPlayer.setOnSurfaceDestroyListener(new APlayerAndroid.OnSurfaceDestroyListener() {

            @Override
            public void onSurfaceDestroy() {
                Log.e(TAG, "event OnSurfaceDestroy");
            }
        });

        aPlayer.setOnShowSubtitleListener(new APlayerAndroid.OnShowSubtitleListener() {

            @Override
            public void onShowSubtitle(String subtitle) {
                Log.e(TAG, "event OnShowSubtitleListener " + subtitle);
                mTextViewSubtitle.setText(subtitle);
            }
        });

        aPlayer.setOnSystemPlayerFailListener(new APlayerAndroid.OnSystemPlayerFailListener() {

            @Override
            public void onSystemPlayerFail() {
                Log.e(TAG, "event OnSystemPlayerFail ");
                aPlayer.setConfig(APlayerAndroid.CONFIGID.HW_DECODER_USE, "1");
            }
        });

        /*aPlayer.setOnReCreateHwDecoderListener(new APlayerAndroid.OnReCreateHwDecoderListener() {
            @Override
            public void onReCreateHwDecoder() {
                if(mIsSystemCallPause){
                    aPlayer.play();
                }else{
                    aPlayer.pause();
                }
            }
        });*/
    }

    private void printfGetConfig(APlayerAndroid mAPlayerAndroid) {
        Log.e(TAG, "APlayerAndroid.CONFIGID,printfGetConfig()");
        Log.e(TAG, "APlayerAndroid.CONFIGID.CLEAR_CONFIG=" + mAPlayerAndroid.getConfig(APlayerAndroid.CONFIGID.CLEAR_CONFIG));
        Log.e(TAG, "APlayerAndroid.CONFIGID.STREAM_TYPE=" + mAPlayerAndroid.getConfig(APlayerAndroid.CONFIGID.STREAM_TYPE));
        Log.e(TAG, "APlayerAndroid.CONFIGID.PLAYRESULT=" + mAPlayerAndroid.getConfig(APlayerAndroid.CONFIGID.PLAYRESULT));
        Log.e(TAG, "APlayerAndroid.CONFIGID.AUTO_PLAY=" + mAPlayerAndroid.getConfig(APlayerAndroid.CONFIGID.AUTO_PLAY));
        Log.e(TAG, "APlayerAndroid.CONFIGID.HARDWARE_RENDER_TYPE=" + mAPlayerAndroid.getConfig(APlayerAndroid.CONFIGID.HARDWARE_RENDER_TYPE));
        Log.e(TAG, "APlayerAndroid.CONFIGID.EXTIO=" + mAPlayerAndroid.getConfig(APlayerAndroid.CONFIGID.EXTIO));
        Log.e(TAG, "APlayerAndroid.CONFIGID.READPOSITION=" + mAPlayerAndroid.getConfig(APlayerAndroid.CONFIGID.READPOSITION));
        Log.e(TAG, "APlayerAndroid.CONFIGID.UPDATEWINDOW=" + mAPlayerAndroid.getConfig(APlayerAndroid.CONFIGID.UPDATEWINDOW));
        Log.e(TAG, "APlayerAndroid.CONFIGID.ORIENTATION_ANGLE=" + mAPlayerAndroid.getConfig(APlayerAndroid.CONFIGID.ORIENTATION_ANGLE));
        Log.e(TAG, "APlayerAndroid.CONFIGID.QUICKLY_MOV_ACTION_COUNT=" + mAPlayerAndroid.getConfig(APlayerAndroid.CONFIGID.QUICKLY_MOV_ACTION_COUNT));
        Log.e(TAG, "APlayerAndroid.CONFIGID.PLAY_SPEED=" + mAPlayerAndroid.getConfig(APlayerAndroid.CONFIGID.PLAY_SPEED));
        Log.e(TAG, "APlayerAndroid.CONFIGID.DOWN_SPEED=" + mAPlayerAndroid.getConfig(APlayerAndroid.CONFIGID.DOWN_SPEED));
        Log.e(TAG, "APlayerAndroid.CONFIGID.STRETCH_MODE=" + mAPlayerAndroid.getConfig(APlayerAndroid.CONFIGID.STRETCH_MODE));
        Log.e(TAG, "APlayerAndroid.CONFIGID.ASPECT_RATIO_NATIVE=" + mAPlayerAndroid.getConfig(APlayerAndroid.CONFIGID.ASPECT_RATIO_NATIVE));
        Log.e(TAG, "APlayerAndroid.CONFIGID.ASPECT_RATIO_CUSTOM=" + mAPlayerAndroid.getConfig(APlayerAndroid.CONFIGID.ASPECT_RATIO_CUSTOM));
        Log.e(TAG, "APlayerAndroid.CONFIGID.LIVE_MODE=" + mAPlayerAndroid.getConfig(APlayerAndroid.CONFIGID.LIVE_MODE));
        Log.e(TAG, "APlayerAndroid.CONFIGID.ONLY_AUDIO=" + mAPlayerAndroid.getConfig(APlayerAndroid.CONFIGID.ONLY_AUDIO));
        Log.e(TAG, "APlayerAndroid.CONFIGID.AUTO_COMPLETE_PLAY=" + mAPlayerAndroid.getConfig(APlayerAndroid.CONFIGID.AUTO_COMPLETE_PLAY));
        Log.e(TAG, "APlayerAndroid.CONFIGID.HW_DECODER_USE=" + mAPlayerAndroid.getConfig(APlayerAndroid.CONFIGID.HW_DECODER_USE));
        Log.e(TAG, "APlayerAndroid.CONFIGID.HW_DECODER_ENABLE=" + mAPlayerAndroid.getConfig(APlayerAndroid.CONFIGID.HW_DECODER_ENABLE));
        Log.e(TAG, "APlayerAndroid.CONFIGID.HW_DECODER_DETEC=" + mAPlayerAndroid.getConfig(APlayerAndroid.CONFIGID.HW_DECODER_DETEC));
        Log.e(TAG, "APlayerAndroid.CONFIGID.AUDIO_TRACK_LIST=" + mAPlayerAndroid.getConfig(APlayerAndroid.CONFIGID.AUDIO_TRACK_LIST));
        Log.e(TAG, "APlayerAndroid.CONFIGID.AUDIO_TRACK_CURRENT=" + mAPlayerAndroid.getConfig(APlayerAndroid.CONFIGID.AUDIO_TRACK_CURRENT));
        Log.e(TAG, "APlayerAndroid.CONFIGID.AUDIO_SILENCE=" + mAPlayerAndroid.getConfig(APlayerAndroid.CONFIGID.AUDIO_SILENCE));
        Log.e(TAG, "APlayerAndroid.CONFIGID.SUBTITLE_USABLE=" + mAPlayerAndroid.getConfig(APlayerAndroid.CONFIGID.SUBTITLE_USABLE));
        Log.e(TAG, "APlayerAndroid.CONFIGID.SUBTITLE_EXT_NAME=" + mAPlayerAndroid.getConfig(APlayerAndroid.CONFIGID.SUBTITLE_EXT_NAME));
        Log.e(TAG, "APlayerAndroid.CONFIGID.SUBTITLE_FILE_NAME=" + mAPlayerAndroid.getConfig(APlayerAndroid.CONFIGID.SUBTITLE_FILE_NAME));
        //Log.e(TAG, "APlayerAndroid.CONFIGID.SUBTITLE_SHOW=" + mAPlayerAndroid.getConfig(APlayerAndroid.CONFIGID.SUBTITLE_SHOW));
        Log.e(TAG, "APlayerAndroid.CONFIGID.SUBTITLE_LANGLIST=" + mAPlayerAndroid.getConfig(APlayerAndroid.CONFIGID.SUBTITLE_LANGLIST));
        Log.e(TAG, "APlayerAndroid.CONFIGID.SUBTITLE_CURLANG=" + mAPlayerAndroid.getConfig(APlayerAndroid.CONFIGID.SUBTITLE_CURLANG));
        Log.e(TAG, "APlayerAndroid.CONFIGID.SUBTITLE_SHOW_EXTERNAL=" + mAPlayerAndroid.getConfig(APlayerAndroid.CONFIGID.SUBTITLE_SHOW_EXTERNAL));
        Log.e(TAG, "APlayerAndroid.CONFIGID.SUBTITLE_CORRECTION=" + mAPlayerAndroid.getConfig(APlayerAndroid.CONFIGID.SUBTITLE_CORRECTION));
        Log.e(TAG, "APlayerAndroid.CONFIGID.HTTP_COOKIE=" + mAPlayerAndroid.getConfig(APlayerAndroid.CONFIGID.HTTP_COOKIE));
        Log.e(TAG, "APlayerAndroid.CONFIGID.HTTP_REFERER=" + mAPlayerAndroid.getConfig(APlayerAndroid.CONFIGID.HTTP_REFERER));
        Log.e(TAG, "APlayerAndroid.CONFIGID.HTTP_CUSTOM_HEADERS=" + mAPlayerAndroid.getConfig(APlayerAndroid.CONFIGID.HTTP_CUSTOM_HEADERS));
        Log.e(TAG, "APlayerAndroid.CONFIGID.HTTP_USER_AGENT=" + mAPlayerAndroid.getConfig(APlayerAndroid.CONFIGID.HTTP_USER_AGENT));
        Log.e(TAG, "APlayerAndroid.CONFIGID.HTTP_USER_AHTTP=" + mAPlayerAndroid.getConfig(APlayerAndroid.CONFIGID.HTTP_USER_AHTTP));
        Log.e(TAG, "APlayerAndroid.CONFIGID.HTTP_AHTTP_CACHE_DIR=" + mAPlayerAndroid.getConfig(APlayerAndroid.CONFIGID.HTTP_AHTTP_CACHE_DIR));
        Log.e(TAG, "APlayerAndroid.CONFIGID.HTTP_AHTTP_USE_CACHE=" + mAPlayerAndroid.getConfig(APlayerAndroid.CONFIGID.HTTP_AHTTP_USE_CACHE));
        Log.e(TAG, "APlayerAndroid.CONFIGID.HTTP_USER_AHTTP2=" + mAPlayerAndroid.getConfig(APlayerAndroid.CONFIGID.HTTP_USER_AHTTP2));
        Log.e(TAG, "APlayerAndroid.CONFIGID.NET_BUFFER_ENTER=" + mAPlayerAndroid.getConfig(APlayerAndroid.CONFIGID.NET_BUFFER_ENTER));
        Log.e(TAG, "APlayerAndroid.CONFIGID.NET_BUFFER_LEAVE=" + mAPlayerAndroid.getConfig(APlayerAndroid.CONFIGID.NET_BUFFER_LEAVE));
        Log.e(TAG, "APlayerAndroid.CONFIGID.NET_BUFFER_READ=" + mAPlayerAndroid.getConfig(APlayerAndroid.CONFIGID.NET_BUFFER_READ));
        Log.e(TAG, "APlayerAndroid.CONFIGID.NET_BUFFER_READ_TIME=" + mAPlayerAndroid.getConfig(APlayerAndroid.CONFIGID.NET_BUFFER_READ_TIME));
        Log.e(TAG, "APlayerAndroid.CONFIGID.NET_SEEKBUFFER_WAITTIME=" + mAPlayerAndroid.getConfig(APlayerAndroid.CONFIGID.NET_SEEKBUFFER_WAITTIME));
        Log.e(TAG, "APlayerAndroid.CONFIGID.VR_ENABLE=" + mAPlayerAndroid.getConfig(APlayerAndroid.CONFIGID.VR_ENABLE));
        Log.e(TAG, "APlayerAndroid.CONFIGID.VR_ROTATE=" + mAPlayerAndroid.getConfig(APlayerAndroid.CONFIGID.VR_ROTATE));
        Log.e(TAG, "APlayerAndroid.CONFIGID.VR_FOVY=" + mAPlayerAndroid.getConfig(APlayerAndroid.CONFIGID.VR_FOVY));
        Log.e(TAG, "APlayerAndroid.CONFIGID.VR_MODEL=" + mAPlayerAndroid.getConfig(APlayerAndroid.CONFIGID.VR_MODEL));
        Log.e(TAG, "APlayerAndroid.CONFIGID.VR_ENABLE_INNER_TOUCH_ROTATE=" + mAPlayerAndroid.getConfig(APlayerAndroid.CONFIGID.VR_ENABLE_INNER_TOUCH_ROTATE));
        Log.e(TAG, "APlayerAndroid.CONFIGID.VR_DISTORTION_CORRECTION=" + mAPlayerAndroid.getConfig(APlayerAndroid.CONFIGID.VR_DISTORTION_CORRECTION));
        Log.e(TAG, "APlayerAndroid.CONFIGID.SEEK_ENABLE=" + mAPlayerAndroid.getConfig(APlayerAndroid.CONFIGID.SEEK_ENABLE));
        Log.e(TAG, "APlayerAndroid.CONFIGID.RECORD_BIT=" + mAPlayerAndroid.getConfig(APlayerAndroid.CONFIGID.RECORD_BIT));
        Log.e(TAG, "APlayerAndroid.CONFIGID.RECORD_WIDTH=" + mAPlayerAndroid.getConfig(APlayerAndroid.CONFIGID.RECORD_WIDTH));
        Log.e(TAG, "APlayerAndroid.CONFIGID.RECORD_HEIGHT=" + mAPlayerAndroid.getConfig(APlayerAndroid.CONFIGID.RECORD_HEIGHT));
        Log.e(TAG, "APlayerAndroid.CONFIGID.RECORD_MODE=" + mAPlayerAndroid.getConfig(APlayerAndroid.CONFIGID.RECORD_MODE));
        Log.e(TAG, "APlayerAndroid.CONFIGID.FRAMERATE_CURRENT=" + mAPlayerAndroid.getConfig(APlayerAndroid.CONFIGID.FRAMERATE_CURRENT));
        Log.e(TAG, "APlayerAndroid.CONFIGID.FRAMERATE_NUM=" + mAPlayerAndroid.getConfig(APlayerAndroid.CONFIGID.FRAMERATE_NUM));
        Log.e(TAG, "APlayerAndroid.CONFIGID.FRAMERATE_INTERNAL=" + mAPlayerAndroid.getConfig(APlayerAndroid.CONFIGID.FRAMERATE_INTERNAL));
    }

    private void setPlayerView(boolean isUseVR) {
        if(!isUseVR) {
            aPlayer.setView(mSurView);
        }
    }

    private void setPlayerParameter() {
        //aPlayer.UseSystemPlayer(true);
        //aPlayer.UseSystemPlayer(false);

        Map<String, String> configParam = mAPlayerParam.getConfigParam();
        if (null != configParam) {
            PropertyNameToConfigID propertyNameToConfigID = PropertyNameToConfigID.getInstance(this);
            for (Map.Entry<String, String> entry : configParam.entrySet()) {
                Integer integer = propertyNameToConfigID.getIDByName(entry.getKey());
                if(null == integer){
                    continue;
                }

                int configID = integer.intValue();
                if (0 != aPlayer.setConfig(configID, entry.getValue())) {
                    Log.e(TAG, "SetConfig() faile " + "configID = " + configID + " val = " + entry.getValue());
                }
            }
        }

    }

    private void play() {
        /*APlayerAndroid.OnPreOpenProgressListener preOpenProgressListener = new APlayerAndroid.OnPreOpenProgressListener() {
            @Override
            public int preOpenProgress(int progress) {
                Log.i(TAG,"preOpenProgress " + progress );
                return 1;
            }
        };

        String str  = "http://aplayer.open.xunlei.com/test.mp4";
        long preOpenObj = APlayerAndroid.preOpen(str,true,1000,preOpenProgressListener);*/
       // APlayerAndroid.closePreOpen(preOpenObj);
       // return;

        if (null == aPlayer) {
            Log.e(TAG, "null == aPlayer");
            return;
        }

        aPlayer.setView(mSurView);

        if(mUri.startsWith("content://")){
            try {
                mpDescriptor = PlayerActivity.this.getContentResolver().openFileDescriptor(Uri.parse(mUri), "r");
                if (mpDescriptor != null) {
                    FileDescriptor fd = mpDescriptor.getFileDescriptor();
                    Log.e("meeeee","open from descriptor");
                    aPlayer.open(fd);
                }
            } catch (Exception e){

            }

        } else {
            aPlayer.open(mUri);
        }

    }
    int pos = 7000;
    private void registerListener() {
        // Set up the user interaction to manually show or hide the system UI.
        View.OnTouchListener playViewClick = new View.OnTouchListener() {
            @Override
            public boolean onTouch(View view, MotionEvent motionEvent) {
                if(MotionEvent.ACTION_DOWN != motionEvent.getAction())
                {
                    return true;
                }

                toggle();
                PlayerActivity.this.destroyPopWind();
                return true;
            }

        };

        mRootView.setOnTouchListener(playViewClick);
        mContentView.setOnTouchListener(playViewClick);

        mPlayPauseSwitchButton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                if (null == aPlayer) {
                    return;
                }
                if (aPlayer.getState() == APlayerAndroid.PlayerState.APLAYER_PAUSED) {
                    mPlayPauseSwitchButton.setImageResource(R.drawable.btn_stop);
                    aPlayer.play();

                } else {
                    mPlayPauseSwitchButton.setImageResource(R.drawable.btn_play);
                    aPlayer.pause();
                }
            }
        });

        mPlayNextButton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                //playPreviousOrNext(true);
                //testParseThumbnail(aPlayer.getPosition(),-1,-1);
                aPlayer.setPosition(pos);
                pos += 200000;
            }
        });

        mPlayPreButton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                playPreviousOrNext(false);
            }
        });


        mPlayModeButton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                if (null == aPlayer) {
                    return;
                }
                String pre_only_audio = aPlayer.getConfig(APlayerAndroid.CONFIGID.ONLY_AUDIO);
                String only_audio = "1";

                if(pre_only_audio.equalsIgnoreCase("1"))
                    only_audio = "0";
                if(only_audio.equals("0")){
                    mPlayModeButton.setImageResource(R.drawable.btn_play_mode_av);
                } else {
                    mPlayModeButton.setImageResource(R.drawable.btn_play_mode_a);
                }
                aPlayer.setConfig(APlayerAndroid.CONFIGID.ONLY_AUDIO,only_audio);

                /*Thread thread = new Thread() {
                    public void run() {

                        Log.e("meee", "start getCurrentScreenshot");
                        Bitmap bitmap = aPlayer.getCurrentScreenshot();
                        Log.e("meee", "end getCurrentScreenshot");
                        String filePath = Environment.getExternalStorageDirectory() + "/a.jpeg";
                        if (filePath == null) {
                            //return null;
                        }

                        FileOutputStream fos;
                        try {
                            fos = new FileOutputStream(filePath);
                            bitmap.compress(Bitmap.CompressFormat.JPEG, 100, fos);
                            fos.close();
                        } catch (Exception e) {
                            Log.e("meee", "FileNotFoundException", e);
                        }

                    }
                };*/
                //thread.start();
                //aPlayer.setPosition(pos,true);
                //pos += 60 * 1000;
                //aPlayer.setPosition(0);
                //aPlayer.setConfig(APlayerAndroid.CONFIGID.SUBTITLE_FILE_NAME, null);
                //aPlayer.close();
                //aPlayer.play();
            }
        });

        mReplayModeButton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
//                String audio_silence = aPlayer.getConfig(APlayerAndroid.CONFIGID.AUDIO_SILENCE);
//                if ( audio_silence.equals("1") ) {
//                    aPlayer.setConfig(APlayerAndroid.CONFIGID.AUDIO_SILENCE, "0");
//                } else if ( audio_silence.equals("0") ){
//                    aPlayer.setConfig(APlayerAndroid.CONFIGID.AUDIO_SILENCE, "1");
//                }
//                String Stretch_mode = aPlayer.getConfig(APlayerAndroid.CONFIGID.STRETCH_MODE);
//                Log.i(TAG, "Stretch_mode="+Stretch_mode);
//                if ( Stretch_mode.equals("0") ) {
//                    aPlayer.setConfig(APlayerAndroid.CONFIGID.STRETCH_MODE, "1");
//                } else if ( Stretch_mode.equals("1") ) {
//                    aPlayer.setConfig(APlayerAndroid.CONFIGID.STRETCH_MODE, "2");
//                } else if ( Stretch_mode.equals("2") ) {
//                    aPlayer.setConfig(APlayerAndroid.CONFIGID.STRETCH_MODE, "3");
//                } else if ( Stretch_mode.equals("3") ) {
//                    aPlayer.setConfig(APlayerAndroid.CONFIGID.STRETCH_MODE, "0");
//                } else {
//                    aPlayer.setConfig(APlayerAndroid.CONFIGID.STRETCH_MODE, "0");
//                }

                new Thread(new Runnable() {
                    @Override
                    public void run() {
                        Log.e(TAG, "aPlayer.getCurrentScreenshot(),run()");
                        Bitmap bitmap = aPlayer.getCurrentScreenshot();
                        if ( bitmap!=null ) {
                            Log.e(TAG, "bitmap!=null");
                            final String filePath = Environment.getExternalStorageDirectory() + "/out.jpeg";
                            FileOutputStream fos;
                            try {
                                fos = new FileOutputStream(filePath);
                                bitmap.compress(Bitmap.CompressFormat.JPEG, 100, fos);
                                fos.close();
                            } catch (Exception e) {
                                Log.e("meee", "FileNotFoundException", e);
                            }
                            PlayerActivity.this.runOnUiThread(new Runnable() {
                                @Override
                                public void run() {
                                    Toast.makeText(getApplicationContext(), "filePath = " + filePath, Toast.LENGTH_SHORT).show();
                                }
                            });
                        } else {
                            Log.e(TAG, "bitmap==null");
                        }

                        Log.e(TAG, "aPlayer.getCurrentScreenshot(),exit()");
                    }
                }).start();
            }
        });


        mSeekBarPlayProgress.setOnSeekBarChangeListener(new SeekBar.OnSeekBarChangeListener() {
            private static final int SEEK_MIN_GATE_MS = 1000;

            @Override
            public void onProgressChanged(SeekBar seekBar, int progress, boolean fromUser) {
                if (null == aPlayer || !fromUser) {
                    return;
                }
                mThumbnailThread.setPosition(progress);
                mIsTouchingSeekbar = true;
                setTimeTextView(mTextViewCurrentTime, progress);
                //userSeekPlayProgress(progress);
            }

            @Override
            public void onStartTrackingTouch(SeekBar seekBar) {
                Log.e(TAG, "onStartTrackingTouch");
                mThumbnail.setImageResource(getResources().getIdentifier("ic_menu_gallery", "drawable", "android"));
                mThumbnail.setVisibility(View.VISIBLE);
                mThumbnailThread.start();
            }

            @Override
            public void onStopTrackingTouch(SeekBar seekBar) {
                userSeekPlayProgress(seekBar.getProgress());
                mThumbnailThread.stop();
                mThumbnail.setVisibility(View.INVISIBLE);
                mTextViewSeekTime.setVisibility(View.INVISIBLE);
                mIsTouchingSeekbar = false;

                startUIUpdateThread();
            }
        });

        mBtnPlaySeting.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                if (null == mPopupWindow) {
//                    int height = PlayerActivity.this.mSurView.getHeight();
//                    int widht = PlayerActivity.this.mSurView.getWidth();

                    int height = mRootView.getHeight();
                    int widht = mRootView.getWidth();

                    String msg = String.format("height = %d, wideght = %d", height, widht);

                    //屏幕可能旋转，取得较小的一边
                    int length = (height > widht) ? widht : height;
                    final int MARGIN = 200;
                    length -= MARGIN;
                    Toast.makeText(mContext, msg, Toast.LENGTH_LONG).show();
                    //View parentView  = PlayerActivity.this.mSurView;
                    View parentView = mRootView;
                    mPopupWindow = new PlayerPopupWindow(mPlayConfig, parentView, mUri, length, length);
                    mPopupWindow.showAtLocation(parentView, Gravity.CENTER|Gravity.LEFT, 0, 0);
                }
            }
        });

    }

    private void playPreviousOrNext(boolean isNext){
        if(mPlayList != null){
            int currentPlayIndx = mPlayList.indexOf(mUri);
            if(currentPlayIndx == -1){
                Log.e(TAG,"err plist indx");
                return;
            }
            String nextPath = null;
            if(isNext){
                int nextIndx = currentPlayIndx >=mPlayList.size()-1?currentPlayIndx:++currentPlayIndx;
                nextPath = mPlayList.get(nextIndx);
            } else {
                int previousIndx = currentPlayIndx <=0?0:--currentPlayIndx;
                nextPath = mPlayList.get(previousIndx);
            }

            if(nextPath == null){
                return;
            }
            if(aPlayer != null){
                aPlayer.pause();
                aPlayer.close();
                mUri = nextPath;
                mHandler.removeCallbacks(mOpenNext);
                mHandler.postDelayed(mOpenNext,600);
            }
        }
    }

    private Runnable mOpenNext = new Runnable() {
        @Override
        public void run() {
            aPlayer.open(mUri);
        }
    };

    private boolean isOverSeekGate(int seekBarPositionMs, int currentPlayPosMs) {
        final int SEEK_MIN_GATE_MS = 1000;
        boolean isChangeOverSeekGate = Math.abs(currentPlayPosMs - seekBarPositionMs) > SEEK_MIN_GATE_MS;
        return isChangeOverSeekGate;
    }

    private void userSeekPlayProgress(int seekPostionMs) {
        int currentPlayPos = aPlayer.getPosition();
        boolean isChangeOverSeekGate = isOverSeekGate(seekPostionMs, currentPlayPos);
        if (!isChangeOverSeekGate) {
            //避免拖动粒度过细，拖动时频繁定位影响体验
            return;
        }

        mIsTouchingSeekbar = true;
        stopUIUpdateThread();
        //mSeekBarPlayProgress.setProgress(seekPostionMs);
        setTimeTextView(mTextViewCurrentTime, seekPostionMs);
        setTimeTextView(mTextViewSeekTime, seekPostionMs);
        mTextViewSeekTime.setVisibility(View.VISIBLE);

        aPlayer.setPosition(seekPostionMs);
        //makeScreenShort(seekPostionMs);
        Log.e(TAG, "current time = " + currentPlayPos);
        Log.e(TAG, "onProgressChanged to " + seekPostionMs);
    }

    private void makeScreenShort(int ms){
        APlayerAndroid.MediaInfo ifo = aPlayer.parseThumbnail(ms,640,480);
        if(ifo == null){
            Log.e("meeee","info null");
            return;
        }
        if(ifo.bitMap == null){
            Log.e("meeee","info.bmp null");
            return;
        }
        Bitmap bmp = ifo.bitMap;//APlayerAndroid.MediaInfo.byteArray2BitMap(ifo.bitMap);
        if(bmp == null){
            return;
        }
        try {
            String path = Environment.getExternalStorageDirectory()+"/000thumb";
            File dir = new File(path);
            if(!dir.exists()){
                if(!dir.mkdir()){
                    Log.e("meeeePlayerActivity","file create failed");
                }
            }
            String JPGPath = path + "/thumb_"+ms+".jpg";
            FileOutputStream fos = new FileOutputStream(new File(JPGPath));
            bmp.compress(Bitmap.CompressFormat.JPEG,70,fos);
            fos.close();
            MediaScannerConnection.scanFile(this, new String[]{JPGPath}, null, new MediaScannerConnection.OnScanCompletedListener() {
                @Override
                public void onScanCompleted(final String path, final Uri uri) {
                    Log.e("meeee",path +":"+uri);
                    mHandler.post(new Runnable() {
                        @Override
                        public void run() {
                            if(uri != null){
                                Toast.makeText(PlayerActivity.this,"截图成功："+path,Toast.LENGTH_SHORT).show();
                            }
                        }
                    });
                }
            });
        }catch (Exception e){
            Log.e("meeee","makeScreenShort failed");
        } finally {
            bmp.recycle();
        }
        bmp = null;
    }

    //
    private boolean isPlay(int status) {
        if (APlayerAndroid.PlayerState.APLAYER_PLAY == status ||
                APlayerAndroid.PlayerState.APLAYER_PLAYING == status) {
            return true;
        }

        return false;
    }

    private void startUIUpdateThread() {
        if (null == mUpdateThread) {
            mIsNeedUpdateUIProgress = true;
            mUpdateThread = new Thread(new UpdatePlayUIProcess());
            mUpdateThread.start();
        } else {
            Log.e(TAG, "null != mUpdateThread");
        }
    }

    private void stopUIUpdateThread() {
        mIsNeedUpdateUIProgress = false;
        mUpdateThread = null;
    }

    private String parseMediaPath(Uri uri)
    {
        if(null == uri){
            return null;
        }

        String path = uri.toString();
        final String scheme = uri.getScheme();
        final String LOCAL_FILE_SCHEME = "file";
        //仅仅对本地文件立即进行Decode
        if(null != scheme && LOCAL_FILE_SCHEME.equalsIgnoreCase(scheme)) {
            path = uri.getEncodedPath();
            path = Uri.decode(path);
        }

        return path;
    }

    @Override
    public void onOptionsMenuClosed(Menu menu) {
        super.onOptionsMenuClosed(menu);
    }

    int cnt = 0;
    public void testParseThumbnail(long timeMs, int width, int height){
        cnt++;
        Log.i(TAG,"testParseThumbnail start");
        APlayerAndroid.MediaInfo mediaInfo = aPlayer.parseThumbnail(timeMs, width, height);
        Bitmap bitmap = mediaInfo.bitMap;//APlayerAndroid.MediaInfo.byteArray2BitMap(mediaInfo.bitMap);
        Log.i(TAG,"testParseThumbnail leave");

        /*String savePath = Environment.getExternalStorageDirectory() + "/test_" + cnt + ".jpg";
        File filePic;
        try {
            filePic = new File(savePath);

            FileOutputStream fos = new FileOutputStream(filePic);
            bitmap.compress(Bitmap.CompressFormat.JPEG, 100, fos);
            fos.flush();
            fos.close();
        } catch (Exception e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }*/
    }

    public class ThumbnailThread implements Runnable {
        private Thread mThread = null;
        private boolean mRunFlag = false;
        private int mMillisecond = -1;
        private int mTid = -1;
        private final ReentrantLock mThumbnailLock = new ReentrantLock(true);
        public int start() {
            if ( mThread != null ) {
                return -1;
            }
            mThread = new Thread(this);
            mRunFlag = true;
            mThread.start();
            return 0;
        }

        public int stop() {
            if ( mThread == null ) {
                return -1;
            }
            mRunFlag = false;
            try {
                mThread.join(10);
            } catch ( InterruptedException e ) {
                e.printStackTrace();
            }
            mThread = null;
            return 0;
        }

        public int setPosition(int msec) {
            mMillisecond = msec;
            return 0;
        }

        @Override
        public void run() {
            Log.e(TAG, "ThumbnailThread,run(),enter");
            final int iTid = android.os.Process.myTid();
            mTid = iTid;
            mThumbnailLock.lock();
            Log.e(TAG, "ThumbnailThread,run(),enter,tid=" + iTid + ",mTid=" + mTid);
            while ( mRunFlag && mTid == iTid ) {
                if ( mMillisecond >= 0 && aPlayer != null ) {
                    int millisecond = mMillisecond;
                    mMillisecond = -1;
                    APlayerAndroid.MediaInfo mediaInfo = aPlayer.parseThumbnail(millisecond, 100, 100);
                    if ( mediaInfo != null && mediaInfo.bitMap != null ) {
                        final Bitmap bitmap = mediaInfo.bitMap;//APlayerAndroid.MediaInfo.byteArray2BitMap(mediaInfo.bitMap);
                        PlayerActivity.this.runOnUiThread(new Runnable() {
                            @Override
                            public void run() {
                                mThumbnail.setImageBitmap(bitmap);
                            }
                        });
                    }
                } else {
                    try {
                        Thread.sleep(10);
                    } catch ( InterruptedException e ) {
                        e.printStackTrace();
                    }
                }
            }
            mThumbnailLock.unlock();
            Log.e(TAG, "ThumbnailThread,run(),exit,tid=" + iTid + ",mTid=" + mTid);
        }
    }
}
