package com.xunlei.aplyer.aplayerdemo.adapter;

import android.content.Context;
import android.graphics.Bitmap;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AbsListView;
import android.widget.AdapterView;
import android.widget.BaseAdapter;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.TextView;

import com.aplayer.APlayerAndroid;
import com.xunlei.aplyer.aplayerdemo.R;
import com.xunlei.aplyer.aplayerdemo.model.FileItemInfo;
import com.xunlei.aplyer.aplayerdemo.util.TimeUtil;

import java.util.ArrayList;
import java.util.List;

public class FilePickerListViewAdapter extends BaseAdapter{
	private Context context;
	private List<FileItemInfo> fileList;
	private static final int thumbnailWidth = 48;
	private static final int thumbnailHeight = 48;
	private static final int  snapsTimeMs = 20*1000;
	private int mResource;
	private LayoutInflater mInflater;

	public FilePickerListViewAdapter(Context context, int resID, List<FileItemInfo> fileList) {
		this.context = context;
		mResource = resID;
		mInflater = LayoutInflater.from(context);
		this.fileList = fileList;
	}
	@Override
	public int getCount() {
		return this.fileList.size();
	}

	@Override
	public Object getItem(int position) {
		return null;
	}

	@Override
	public long getItemId(int position) {
		return 0;
	}

	@Override
	public View getView(final int position, View convertView, final ViewGroup parent) {
		final View view;
		if (convertView == null) {
			view = mInflater.inflate(mResource, parent, false);
		} else {
			view = convertView;
		}
		FileItemInfo fileInfo = fileList.get(position);
		ImageView videoThumbnailImageView = (ImageView)view.findViewById(R.id.videoThumbnailImageView);
		TextView fileNameTextView = (TextView)view.findViewById(R.id.fileNameTextView);
		TextView videoDurationTextView = (TextView)view.findViewById(R.id.durationTextView);
		TextView videoResolutionTextView = (TextView)view.findViewById(R.id.resolutionTextView);
		LinearLayout itemInfos = (LinearLayout)view.findViewById(R.id.itemInfos);
		ImageView doWhatBtn = (ImageView)view.findViewById(R.id.do_what);
		videoThumbnailImageView.setOnClickListener(new View.OnClickListener() {
			@Override
			public void onClick(View v) {
				((AbsListView)parent).performItemClick(v,position,position);
			}
		});

		itemInfos.setOnClickListener(new View.OnClickListener() {
			@Override
			public void onClick(View v) {
				((AbsListView)parent).performItemClick(v,position,position);
			}
		});
		doWhatBtn.setOnClickListener(new View.OnClickListener() {
			@Override
			public void onClick(View v) {
				((AbsListView)parent).performItemClick(v,position,position);
			}
		});

		videoDurationTextView.setText("");
		videoResolutionTextView.setText("");
		fileNameTextView.setText(fileInfo.name);
		if (fileInfo.isDirectory) {
			videoThumbnailImageView.setImageResource(R.drawable.ic_folder);
			doWhatBtn.setVisibility(View.INVISIBLE);
		} else {
			doWhatBtn.setVisibility(View.VISIBLE);
			APlayerAndroid.MediaInfo mediaInfo = fileInfo.mediaInfo;
			if(null != mediaInfo){
				if (mediaInfo.bitMap != null) {
					Bitmap bitmap = mediaInfo.bitMap;//APlayerAndroid.MediaInfo.byteArray2BitMap(mediaInfo.bitMap);
					if(null != bitmap) {
						videoThumbnailImageView.setImageBitmap(bitmap);
					}
				} else {
					videoThumbnailImageView.setImageResource(R.drawable.ic_document_file_48px);
				}

				final int MILLSECONDS_TIME_BASE = 1000;
				if (mediaInfo.duration_ms > 0) {
					int timeSeconds = (int)(mediaInfo.duration_ms / MILLSECONDS_TIME_BASE);
					videoDurationTextView.setText(TimeUtil.formatFromSecond(timeSeconds));
				}

				String rational = "";
				if(mediaInfo.width!=0 && mediaInfo.height!=0){
					rational = String.format("%dx%d", mediaInfo.width, mediaInfo.height);
				}
				videoResolutionTextView.setText(rational);
			} else {
				videoThumbnailImageView.setImageResource(R.drawable.ic_document_file_48px);
			}
		}
		return view;
	}

	public ArrayList<FileItemInfo> getVideoFileList() {
		return (ArrayList<FileItemInfo>)fileList;
	}
}
