package com.xunlei.aplyer.aplayerdemo.util;

import java.lang.ref.WeakReference;

import com.aplayer.APlayerAndroid;
import com.xunlei.aplyer.aplayerdemo.model.FileItemInfo;
import com.xunlei.aplyer.aplayerdemo.model.ThumbnailParam;

import android.nfc.Tag;
import android.os.AsyncTask;
import android.util.Log;

public class AsyncVideoThumbnailFetcherTask extends AsyncTask<Void, Void, FileItemInfo> {
	private final WeakReference<VideoInfoLoader.VideoInfoSettable> listViewRef;
	private ThumbnailParam thumbnailParam;
	private static APlayerAndroid aPlayer = new APlayerAndroid();

	public AsyncVideoThumbnailFetcherTask(VideoInfoLoader.VideoInfoSettable listItemView, ThumbnailParam thumbnailParam) {

		this.thumbnailParam = thumbnailParam;
		listViewRef = new WeakReference<VideoInfoLoader.VideoInfoSettable>(listItemView);
	}

	@Override
	protected FileItemInfo doInBackground(Void... params) {
		if(null == thumbnailParam || null == thumbnailParam.path || thumbnailParam.path.isEmpty())
			return null;

		Log.i("APlayerAndroid","thumbnailParam name = " + thumbnailParam.name);
		APlayerAndroid.MediaInfo mediaInfo = APlayerAndroid.parseThumbnail(thumbnailParam.path,
				thumbnailParam.snapsTimeMs, thumbnailParam.width, thumbnailParam.height);
		if(mediaInfo != null) {
			Log.i("APlayerAndroid", "name = " + thumbnailParam.name + " mediaInfo angle = " + mediaInfo.angle + " height  = " + mediaInfo.height + " width = " + mediaInfo.width + " duration = " + mediaInfo.duration_ms);
		}
		FileItemInfo fileItem = new FileItemInfo();
		fileItem.isDirectory = false;
		fileItem.name = thumbnailParam.name;
		fileItem.path = thumbnailParam.path;
		fileItem.mediaInfo = mediaInfo;
		return fileItem;

	}

	@Override
	protected void onPostExecute(FileItemInfo fileItemInfo) {
		if (isCancelled() && fileItemInfo != null) {
			fileItemInfo = null;
		}
		//if (fileItemInfo != null && fileItemInfo.mediaInfo != null ) {
		if ( fileItemInfo != null ) {
			//if(fileItemInfo.mediaInfo.hasVideo || fileItemInfo.mediaInfo.hasAudio){
				final VideoInfoLoader.VideoInfoSettable listView = listViewRef.get();
				if(null != listView){
					listView.refreshMediaInfo(fileItemInfo);
				}
			//}
		}
	}
}
