package com.xunlei.aplyer.aplayerdemo.view;

import android.Manifest;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.pm.PackageManager;
import android.media.Image;
import android.os.AsyncTask;
import android.os.Environment;
import android.os.Handler;
import android.support.v4.app.ActivityCompat;
import android.support.v4.content.ContextCompat;
import android.support.v7.app.AlertDialog;
import android.view.LayoutInflater;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.View;
import android.widget.AdapterView;
import android.widget.EditText;
import android.widget.ImageButton;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.PopupMenu;
import android.widget.TextView;
import android.widget.Toast;

import com.aplayer.APlayerAndroid;
import com.aplayer.Log;
import com.xunlei.aplyer.aplayerdemo.FilePickerActivity;
import com.xunlei.aplyer.aplayerdemo.R;
import com.xunlei.aplyer.aplayerdemo.SettingActivity;
import com.xunlei.aplyer.aplayerdemo.adapter.FilePickerListViewAdapter;
import com.xunlei.aplyer.aplayerdemo.model.Content;
import com.xunlei.aplyer.aplayerdemo.model.FileItemInfo;
import com.xunlei.aplyer.aplayerdemo.model.ThumbnailParam;
import com.xunlei.aplyer.aplayerdemo.util.AsyncVideoThumbnailFetcherTask;
import com.xunlei.aplyer.aplayerdemo.util.CommonConst;
import com.xunlei.aplyer.aplayerdemo.util.VideoFileHelper;
import com.xunlei.aplyer.aplayerdemo.util.VideoInfoLoader;

import java.io.File;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;

/**
 * Created by admin on 2016/7/19.
 */
public class FilePickerView extends LinearLayout implements VideoInfoLoader.VideoInfoSettable {

    private static final String ERROR_TAG = Content.APLAYER_DEMO_LOG_PREF_TAG + FilePickerView.class.getSimpleName();
    private static final String WARE_TAG = ERROR_TAG;
    private Handler mHandler;
    private Context mContext;
    private View mRootView;
    private View mParentFolderBtn;
    private ImageView mRefrshBtn;
    private ImageView mOpenUriBtn;
    private ImageView mPreOpenUriBtn;
    private ImageView mScanQRBtn;
    private TextView mCurPathTextView;
    private ImageView mSettingView;
    private FilePickListener mFilePickListener;
    private FileMoreOperateListener mFileMoreOPerateListener;
    private ListView mFileListView;
    private static final String ROOT = Content.PATH_ROOT;
    private String mCurDirPath = ROOT;
    private ArrayList<FileItemInfo> mFileList = new ArrayList<FileItemInfo>();
    private ArrayList<FileItemInfo> mDirList = new ArrayList<FileItemInfo>();
    private ArrayList<String> mPlayableList = new ArrayList<>();//当前目录的可播放文件列表
    private FilePickerListViewAdapter mAdapter;
    private ArrayList<AsyncTask> mTaskList = new ArrayList<>();
    public FilePickerView(Context context, FilePickListener filePickListener, String currentDir) {
        super(context);
        mHandler = new Handler();
        mContext = context;
        mFilePickListener = filePickListener;
        mRootView =  LayoutInflater.from(context).inflate(R.layout.file_picker, this);
        //mFileListView = (ListView) mRootView.findViewById(R.id.fileListView);

        mParentFolderBtn = findViewById(R.id.to_pre_dir);
        mParentFolderBtn.setOnClickListener(mParentFolderBtnOnClickListener);
        mRefrshBtn = (ImageView) findViewById(R.id.refresh_dir);
        mRefrshBtn.setOnClickListener(new OnClickListener() {
            @Override
            public void onClick(View v) {
                updateFileList(mCurDirPath);
            }
        });

        mOpenUriBtn = (ImageView) findViewById(R.id.open_url);
        mOpenUriBtn.setOnClickListener(new OnClickListener() {
            @Override
            public void onClick(View v) {
                                inputUrl();
                            }
        });

        mPreOpenUriBtn = (ImageView) findViewById(R.id.pre_open_url);
        mPreOpenUriBtn.setOnClickListener(new OnClickListener() {
            @Override
            public void onClick(View v) {
                inputUrl2();
                String cachePath = Environment.getExternalStorageDirectory().getPath() + "/Ahttp2/1";
                //deleteCacheData(cachePath);
            }
        });

        mScanQRBtn =  (ImageView) findViewById(R.id.scanQRcode);
        mCurPathTextView = (TextView)findViewById(R.id.cur_dir);

        mSettingView = (ImageView)findViewById(R.id.global_player_setting);
        mSettingView.setOnClickListener(new OnClickListener() {
            @Override
            public void onClick(View v) {
                Intent intent = new Intent(mContext, SettingActivity.class);
                mContext.startActivity(intent);
            }
        });

        mFileListView = (ListView)findViewById(R.id.fileListView);
        mFileListView.setOnItemClickListener(mFileListViewOnItemClickListener);
        String rootPath = Environment.getExternalStorageDirectory().getAbsolutePath();
        mCurDirPath = (null == currentDir) ? rootPath : currentDir;
        mCurPathTextView.setText(mCurDirPath);
        mAdapter = new FilePickerListViewAdapter(mContext, R.layout.file_list_item,mFileList);
        mFileListView.setAdapter(mAdapter);
        updateFileList(mCurDirPath);
    }

    public FilePickerView(Context context, String currentDir) {
        this(context,null,currentDir);
    }


    public void setOnSelectListener(FilePickListener filePickListener){
        mFilePickListener = filePickListener;
    }

    public void setOnMoreOperateListener(FileMoreOperateListener moreOperateListener){
        mFileMoreOPerateListener = moreOperateListener;
    }

    public ImageView getmScanQRCodeBtn(){
        return mScanQRBtn;
    }

    private void refreshFileList(FileItemInfo fileInfo)
    {
        mFileList.add(fileInfo);
        FilePickerListViewAdapter filePickerListViewAdapter = (FilePickerListViewAdapter) mFileListView.getAdapter();
        filePickerListViewAdapter.notifyDataSetChanged();
        mPlayableList.add(fileInfo.path);
    }

    private static boolean isVideoFile(String fileName)
    {
        int pos = fileName.lastIndexOf('.');
        String extensionName = (pos >= 0) ? fileName.substring(pos + 1) : null;
        return (null != extensionName && VideoFileHelper.isSupportedVideoFileExtension(extensionName));
    }

    public ArrayList<String> getCurDirPlayableList(){
        return mPlayableList;
    }
    public void updateFileList(String path) {
        if(path.length() < ROOT.length()){
            return;
        }
        mCurDirPath = path;
        notifyOnSlected(mCurDirPath, false);

        //取消未完成的异步任务
        if(!mTaskList.isEmpty()){
            for (AsyncTask task:mTaskList) {
                if(task != null){
                    task.cancel(true);
                }
            }
            mTaskList.clear();
        }

        File dir = new File(path);
        if ((!dir.exists() || !dir.isDirectory()) && !path.equals(ROOT)) {
            mCurPathTextView.setText(ROOT);
            return;
        }
        if (dir.getParentFile() != null) {
            mParentFolderBtn.setVisibility(View.VISIBLE);
        } else {
            mParentFolderBtn.setVisibility(View.GONE);
        }

        mFileList.clear();
        mDirList.clear();

        File[] files = dir.listFiles();
        if (files != null) {
            for (File file : dir.listFiles()) {
                if (file.isHidden()) {
                    continue;
                }
                if (file.isDirectory()) {
                    FileItemInfo fileItem = new FileItemInfo();
                    fileItem.isDirectory = true;
                    fileItem.name = file.getName();
                    fileItem.path = file.getPath();
                    mDirList.add(fileItem);
                } else {
                    //异步加载缩略图
                    final int SNAPS_TIME_MS = 20 * 1000;
                    final int THUMBNAIL_WIDTH = 48;
                    final int THUMBNAIL_HEIGHT = 48;
                    ThumbnailParam thumbnailParam = new ThumbnailParam(file.getName(), file.getPath(), SNAPS_TIME_MS, THUMBNAIL_WIDTH, THUMBNAIL_HEIGHT);
                    AsyncVideoThumbnailFetcherTask asyncVideoThumbnailFetcherTask = new AsyncVideoThumbnailFetcherTask(this, thumbnailParam);
                    asyncVideoThumbnailFetcherTask.execute();
                    mTaskList.add(asyncVideoThumbnailFetcherTask);
                }
            }
        }

        Comparator comp = new FileItemInfo.SortComparator();
        Collections.sort(mDirList,comp);
        Collections.sort(mFileList, comp);
        //lastTask使文件夹都显示在列表里靠后
        AsyncTask lastTask = new AsyncTask<Void,Void,Void>(){
            @Override
            protected Void doInBackground(Void... voids) {
                return null;
            }
            @Override
            protected void onPostExecute(Void aVoid) {
                super.onPostExecute(aVoid);
                mFileList.addAll(mDirList);
                mAdapter.notifyDataSetChanged();
            }
        }.execute();
        mTaskList.add(lastTask);

    }

    private final OnClickListener mParentFolderBtnOnClickListener = new OnClickListener() {
        @Override
        public void onClick(View view) {
            backToPreviousDir();
        }
    };

    public void backToPreviousDir(){

        File curPathDir = new File(mCurDirPath);
        if (!curPathDir.exists() || !curPathDir.isDirectory()) {
            updateFileList(ROOT);
            return;
        }
        File parentFile = curPathDir.getParentFile();
        if (parentFile != null) {
            updateFileList(parentFile.toString());
        }
    }

    private void openMoreOperationMeun(View anchorView, final FileItemInfo fileItemInfo){
        PopupMenu popup = new PopupMenu(getContext(), anchorView);
        MenuInflater inflater = popup.getMenuInflater();
        inflater.inflate(R.menu.video_operator_option, popup.getMenu());
        //if(fileItemInfo.mediaInfo.hasAudio == false){
        //    popup.getMenu().removeItem(R.id.extract_audio);
        //}
        popup.setOnMenuItemClickListener(new PopupMenu.OnMenuItemClickListener() {
            @Override
            public boolean onMenuItemClick(MenuItem item) {
                // TODO Auto-generated method stub
                switch (item.getItemId()) {
                    case R.id.extract_audio:
                        notifyMoreSelected(fileItemInfo, CommonConst.OPERATOR_EXTRACT_AUDIO);
                        break;
                    case R.id.more_operate:
                        Toast.makeText(getContext(), R.string.more_operator, Toast.LENGTH_SHORT).show();
                        break;
                    default:
                        break;
                }
                return false;
            }
        });
        popup.show();
    }



    private final ListView.OnItemClickListener mFileListViewOnItemClickListener = new ListView.OnItemClickListener() {
        @Override
        public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
            FilePickerListViewAdapter adapter = (FilePickerListViewAdapter)parent.getAdapter();
            ArrayList<FileItemInfo> fileList = adapter.getVideoFileList();
            FileItemInfo fileItemInfo = fileList.get(position);
            if (fileItemInfo.isDirectory) {
                updateFileList(fileItemInfo.path);
            } else {
                String videoFilePath = fileList.get(position).path;
                String videoFileName = fileList.get(position).name;
                int viewID = view.getId();

                if(viewID == R.id.do_what){
                    openMoreOperationMeun(view,fileItemInfo);
                } else {
                    notifyOnSlected(videoFilePath, true);
                }

            }
        }
    };

    @Override
    public void refreshMediaInfo(FileItemInfo fileInfo) {
        refreshFileList(fileInfo);
    }

    public interface FilePickListener
    {
        void onSelected(String filePath, boolean isFile);
    }

    public interface FileMoreOperateListener
    {
        void onMoreSelected(FileItemInfo fileInfo,int operator);
    }

    private void notifyMoreSelected(FileItemInfo fileInfo,int operator){
        if(mFileMoreOPerateListener == null)
            return;
        mFileMoreOPerateListener.onMoreSelected(fileInfo,operator);
    }

    private void notifyOnSlected(String filePath, boolean isFile)
    {
        if(null == mFilePickListener)
            return;
        mFilePickListener.onSelected(filePath, isFile);
        if(!isFile){
            mCurPathTextView.setText(filePath);
        }
    }

    public void inputUrl()
    {
        //装载/res/layout/login.xml界面布局
        final LinearLayout urlInputForm = (LinearLayout)LayoutInflater.from(mContext).inflate( R.layout.url_input_layout, null);
        new AlertDialog.Builder(getContext())
                .setIcon(R.drawable.url_address_24px)
                .setTitle("URL")
                .setView(urlInputForm)
                .setPositiveButton("OK" , new DialogInterface.OnClickListener() {
                    @Override
                    public void onClick(DialogInterface dialog, int which) {
                        EditText urlEditText = (EditText) urlInputForm.findViewById(R.id.alter_dlg_url);
                        String urlPath = urlEditText.getText().toString();
                        if(null != urlPath && !urlPath.isEmpty()){
                            notifyOnSlected(urlPath,true);
                        }
                    }
                })
                .setNegativeButton("Cancle", new DialogInterface.OnClickListener() {
                    @Override
                    public void onClick(DialogInterface dialog, int which) {
                        // do nothing
                    }
                })
                .create()
                .show();

    }

    public void deleteCacheData(String str){
        long len = APlayerAndroid.deleteCacheData(str);
        Log.i("APlayerDemo","deleteCacheData len = " + len);
    }

    public void inputUrl2()
    {
        //装载/res/layout/login.xml界面布局
        final LinearLayout urlInputForm = (LinearLayout)LayoutInflater.from(mContext).inflate( R.layout.url_input_layout, null);
        new AlertDialog.Builder(getContext())
                .setIcon(R.drawable.url_address_24px)
                .setTitle("预下载")
                .setView(urlInputForm)
                .setPositiveButton("OK" , new DialogInterface.OnClickListener() {
                    @Override
                    public void onClick(DialogInterface dialog, int which) {
                        EditText urlEditText = (EditText) urlInputForm.findViewById(R.id.alter_dlg_url);
                        String urlPath = urlEditText.getText().toString();
                        if(null != urlPath && !urlPath.isEmpty()){
                            String cachePath = Environment.getExternalStorageDirectory().getPath() + "/Ahttp2/1";
                            File mFile = new File(cachePath+".data");
                            mFile.delete();
                            mFile = new File(cachePath+".rec");
                            mFile.delete();
                            APlayerAndroid.preOpen(urlPath,cachePath,10000,null);
                        }
                    }
                })
                .setNegativeButton("Cancle", new DialogInterface.OnClickListener() {
                    @Override
                    public void onClick(DialogInterface dialog, int which) {
                        // do nothing
                    }
                })
                .create()
                .show();

    }
}
